'''
Tetris game application interface

@author: Jean-Bernard MARTINEZ
'''

from tkinter import *
import subprocess
import platform
import os
import sys
import time
from winreg import DisableReflectionKey

from tetrimino import *

class App(Tk): 
    
    # - - - - - - - - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - VARIABLES APP - - - - - - - - -
    game_board = ''
    buton_go = ''
    posMax = ''
    posX = 0
    posY = 0
    type = ''
    color = ''
    img = ''
    stop = 0
    AppGrid = [
        [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],
        [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],
        [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1]
    ]
    gx = [0,0,0,0]
    gy = [0,0,0,0]
    total = 0 
    gameower = 'false'     



    # - - - - - - - - - - - - - - - - - - - - - - - - -
    # - - - - - - - - ACTION DES TOUCHES - - - - - - - -           
    def action_clavier(self):
        self.posX = self.posX - 34
      
    # - - - - - - - - - - - - - - - - - - - - - - - - -
    # - - - - - - - - ACTION DES BOUTONS - - - - - - - -  
    def close(self):
        self.destroy()
        self.game_board = None
        return
        sys.exit(0)     
 
    def playing(self):

        if self.game_board != None:

            self.buton_go['state'] = DISABLED

            brick = Tetrimino(self.game_board)
            self.photo = brick.getPhoto()
            self.posMax = brick.getPosMax()
            
            self.posY = 17
            i = 0

            while i < self.posMax:           

                if self.stop == 0 and self.game_board != None:
                    # - - - - - - - - GESTION GRILLE - - - - - - - - 
                    for t in range(0, 4):
                        self.gx[t], self.gy[t] = self.game_board.coords(self.photo[brick.item - t])
                        self.gx[t] = round((self.gx[t] - 17) / 34)
                        self.gy[t] = round((self.gy[t] - 17) / 34)

                    for t in range(0, 4):
                        if self.AppGrid[self.gy[t]+1][self.gx[t]] > -1:
                            self.stop = 1

                    for t in range(0, 4):
                        if self.AppGrid[self.gy[t]][self.gx[t]] > -1:
                            self.stop = 1
                            self.gameower = 'true'                        

                    self.game_board.after(180, brick.moveIt(self.game_board, self.posX, self.posY)) 
                    i += 1
                    self.posX = self.posX
                else:
                    break
            
            self.supp()

            if self.gameower == 'false':
                self.stop = 0
            else:
                self.stop = 1

            brick.item += 1

            total = len(self.photo)
            for t in range(0, 4):
                self.AppGrid[self.gy[t]][self.gx[t]] = total - t

            if self.stop == 0:
                self.playing()
            else:
                self.reset()
                self.buton_go['state'] = NORMAL
        
    def help(self):
        my_os = platform.system()
        if my_os == 'Windows':
            os.startfile("help.pdf")
        elif  my_os == 'Darwin':  
           os.startfile("xdg-open help.pdf") 
        else:
           subprocess.call(['xdg-open', 'help.pdf'])
           
      
    def img_url(self, _fichier):
        return os.path.join('img', _fichier)
    

    def reset(self):

        brick = Tetrimino(self.game_board)

        self.stop = 0
        self.AppGrid = [
            [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],
            [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],
            [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1]
        ]
        self.gx = [0,0,0,0]
        self.gy = [0,0,0,0]
        self.total = 0 
        self.gameower = 'false' 

        brick.item = -1
        
        brick.list_photo = [] 

    # - - - - - - - - -  SUPPRIMER LES CUBES SUR UNE LIGNE- - - - - - - - - -
    def supp(self):

        # - - - Récupération ligne plaine
        i = 0
        line = []
        for y in range(0, 16):
            for x in range(0, 9):
                l = 0
                if self.AppGrid[y][x] > -1:
                    l += 1

                if l == 10:
                    line[i] = y
                    i += 1

        # - - - Supprétion des images des ligne plaine
        for l in range(0, i):
            for x in range(0, 9):
                item = line[l]
                self.photo[item].config(image='')

        # - - - Déplasement des cubes suppérieur
        if len(line) > 0:
            max = line[0] - 1 # dernière ligne à déplacer
            nb = len(line) # nombre de ligne de déplacement
            for y in range(0, max):
                for x in range(0, 9):
                    i = self.AppGrid[y][x]
                    self.game_board.after(180, self.photo[i].moveIt(self.game_board, 0, nb * 34)) 
    
    # - - - - - - - - - - - - - - - - - - - - - - - - -
    # - - - - - - -  FONCTION INITIAL - - - - - - - - -
    # - - - - - - - - - - - - - - - - - - - - - - - - -
      
    def __init__(self):
        super().__init__()

        # - - - - - Mur de brique - - - -
        wall_top = Canvas(self, width=408, height=36, bg='#ccc', highlightthickness=0)
        wall_top.pack(side='top')  
        wall_left = Canvas(self, width=34, height=750, bg='#ccc', highlightthickness=0)
        wall_left.pack(side='left')
        wall_right = Canvas(self, width=34, height=750, bg='#ccc', highlightthickness=0)
        wall_right.pack(side='right')
        self.game_board = Canvas(self, width=340, height=612, bg='#000', highlightthickness=0)
        self.game_board.pack(side='top') 
        wall_bottum = Canvas(self, width=340, height=34, bg='#ccc', highlightthickness=0)
        wall_bottum.pack(side='top') 
        
        # - - - - - Image : Mur de brique - - - -      
        graycube = PhotoImage(file= self.img_url('gray-cube.gif'))
        
        for i in range(12):
            photo = wall_top.create_image(17+(i*34), 19, image = graycube)
            
        for i in range(19):
            photo = wall_left.create_image(17, 17+(i*34), image = graycube) 
            photo = wall_right.create_image(17, 17+(i*34), image = graycube)           
            
        for i in range(10):
            photo = wall_bottum.create_image(17+(i*34), 17, image = graycube)
        
        # - - - - - Mise en place : Mur de brique - - - -
        wall_top.photo = graycube
        wall_left.photo = graycube
        wall_right.photo = graycube  
        wall_bottum.photo = graycube           
        
        # - - - - - Zone de bouton - - - -                       
        area_button = Frame(self, width=400, height=50, bg='#ccc')
        area_left = Frame(area_button, width=204, height=50, bg='#ccc')
        area_right = Frame(area_button, width=204, height=50, bg='#ccc')
        area_button.pack(side='top')
        area_left.pack(side='left')
        area_right.pack(side='right') 
        
        # - - - - - bouton - - - -
        self.buton_go = Button(area_left, width=16, height=50, text='JOUER', fg='black', bg='#ccc', command = self.playing, state = NORMAL)
        buton_quit = Button(area_right, width=16, height=50, text='QUITTER', fg='black', bg='#ccc', command = self.close)
        buton_info = Button(area_right, width=10, height=50, text='AIDE', fg='black', bg='#ccc', command = self.help)
        self.buton_go.pack(side='left', padx=5, pady = 5)
        buton_info.pack(side='right', padx=5, pady = 5)
        buton_quit.pack(side='right', padx=5, pady = 5)            
             
        
        left = str(int(self.winfo_screenwidth()/2-408/2))
        top = str(int(self.winfo_screenheight()/2-750/2-20))
        self.title('JBM Tetris® – Applications Jean-Bernard MARTINEZ 2023')
        self.geometry(f'408x750+{left}+{top}')