'''
Tetris game application board

@author: Jean-Bernard MARTINEZ
'''

from tkinter import *
import os
import random
import keyboard

class Tetrimino(Tk):
    
    # - - - - - Position des tétriminos actif - - - -
    posMax = 0
    item = -1
    posX = 0
    posY = 0
    
    # - - - - - - - -  COULEUR DU TETRIMINO - - - - -  - - -
    list_color = ['blue', 'green', 'orange', 'purple', 'red', 'yellow']
    list_type = ['I','O','T','L','J','Z','S']
    color = ''
    img = ''
    photo = ''
    list_photo = [] 
    board = '' 
    
    # - - - - - - - -  TYPE DE TETRIMINOS   - - - - - - - - 
    # - - - - Tétrimino I (Quatre carrés alignés)
    # - - - - Tétrimino O (Méta-carré de 2x2)
    # - - - - Tétrimino T (Trois carrés en ligne et un carré sous le centre)
    # - - - - Tétrimino L (Trois carrés en ligne et un carré sous le côté gauche)
    # - - - - Tétrimino J (Trois carrés en ligne et un carré sous le côté droit)
    # - - - - Tétrimino Z (Méta-carré de 2x2, dont la rangée supérieure est glissée d'un pas vers la gauche)
    # - - - - Tétrimino S (Méta-carré de 2x2, dont la rangée supérieure est glissée d'un pas vers la droite)
    type = ''
    
    def img_url(self, _fichier):
        return os.path.join('img', _fichier)
    
    # - - - - - - - - - - - - - - - - - - - - - - - - -
    # - - - - - DEPLACEMENT DES TETRIMINO - - - -
    def moveIt(self, _board, _posX, _posY):

        self.board = _board
        self.posX = _posX
        self.posY = _posY

        # --- CONTROLE HORISONTAL ---
        x, y = self.board.coords(self.list_photo[self.item] - 3)

        if keyboard.is_pressed('left'):  # Left 
            if self.type == 'S' and x > 51:
                self.posX = -34
            if self.type != 'S' and x > 17:
                self.posX = -34

        if keyboard.is_pressed('right'):  # Right 

            match self.type:
                case 'I':
                    if x < 221: self.posX = 34
                case 'O':
                    if x < 289: self.posX = 34
                case 'T':
                    if x < 255: self.posX = 34
                case 'L':
                    if x < 255: self.posX = 34
                case 'J':
                    if x < 255: self.posX = 34
                case 'Z':
                    if x < 255: self.posX = 34
                case 'S':
                    if x < 289: self.posX = 34                                                                                                                        

        self.posY = self.posY + 17

        for t in range(1, 5):
            self.board.move(self.list_photo[self.item * t], self.posX, self.posY)     
            
        self.board.update_idletasks()
        self.board.update()

        self.posX = 0 
          
        
    # - - - - - - - - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - -  GET - - - - - - - - - - - -
    def getPosMax(self):
        return self.posMax   
      
    def getPosX(self):
        return self.posX
    
    def getPosY(self):
        return self.posY
    
    def getType(self):
        return self.type 
    
    def getColor(self):
        return self.color
    
    def getImage(self):
        return self.img
    
    def getPhoto(self):      
        return self.list_photo 

    def getItem(self):      
        return self.item                                                         
  
    
    # - - - - - - - - - - - - - - - - - - - - - - - - -
    # - - - - - FONCTION INITIAL - - - -  
    def __init__(self, _board):
        
        photo = ''
        self.board = _board
        
        # - - - - -  CHOIX ALEATOIR DU TYPE DE TETRIMINO - - - - -
        random.shuffle(self.list_type)
        self.type = self.list_type[0]  
        
        # - - - - - - - CHOIX ALEATOIR DE LA COULEUR - - - - - - - 
        random.shuffle(self.list_color) 
        self.color = self.list_color[0]      
        
        # - - - - - - - - - SELECTION IMAGE PAR COULEUR - - - - - - - - 
        if self.color == 'blue':
            self.img = PhotoImage(file= self.img_url('blue-cube.gif'))
        elif self.color == 'green':
            self.img = PhotoImage(file= self.img_url('green-cube.gif'))
        elif self.color == 'orange':
            self.img = PhotoImage(file=self.img_url('orange-cube.gif'))
        elif self.color == 'purple':
            self.img = PhotoImage(file= self.img_url('purple-cube.gif'))
        elif self.color == 'red':
            self.img = PhotoImage(file= self.img_url('red-cube.gif'))  
        elif self.color == 'yellow':
            self.img = PhotoImage(file= self.img_url('yellow-cube.gif')) 
            
        # - - - - GENERATION DU TETRIMINO - - - - - - -     
        if self.type == 'I':
            
            self.posMax = 17
            self.posX = 17+(3*34)
            self.posY = 17
            for x in range (0,4):
                photo = self.board.create_image(self.posX + (x * 34), self.posY, image = self.img)
                self.list_photo.append(photo)

        if self.type == 'O':
            
            self.posMax = 16
            self.posX = 17+(4*34)
            self.posY = 17
            
            for y in range (0,2):
                for x in range (0,2):
                    photo = self.board.create_image(self.posX + (x * 34), self.posY + (y * 34), image = self.img) 
                    self.list_photo.append(photo)
                    
        if self.type == 'T':
            
            self.posMax = 16
            self.posX = 17+(3*34)
            self.posY = 17
            
            for x in range (0,3):
                photo = self.board.create_image(self.posX + (x * 34), self.posY, image = self.img)
                self.list_photo.append(photo)
                
            photo = self.board.create_image(self.posX + 34, self.posY + 34, image = self.img)
            self.list_photo.append(photo) 
            
        if self.type == 'L':
            
            self.posMax = 16
            self.posX = 17+(3*34)
            self.posY = 17
            
            for x in range (0,3):
                photo = self.board.create_image(self.posX + (x * 34), self.posY, image = self.img)
                self.list_photo.append(photo)
                
            photo = self.board.create_image(self.posX, self.posY + 34, image = self.img)
            self.list_photo.append(photo)
            
        if self.type == 'J':
            
            self.posMax = 16
            self.posX = 17+(3*34)
            self.posY = 17
            
            for x in range (0,3):
                photo = self.board.create_image(self.posX + (x * 34), self.posY, image = self.img)
                self.list_photo.append(photo)
                
            photo = self.board.create_image(self.posX + (2 * 34), self.posY + 34, image = self.img)
            self.list_photo.append(photo)                                                           
                                                                    
        if self.type == 'Z':
            
            self.posMax = 16
            self.posX = 17+(4*34)
            self.posY = 17
            
            for y in range (0,2):
                for x in range (0,2):
                    photo = self.board.create_image(self.posX + (x * 34) + (y * 34), self.posY + (y * 34), image = self.img) 
                    self.list_photo.append(photo)
            
        if self.type == 'S':
            
            self.posMax = 16
            self.posX = 17+(4*34)
            self.posY = 17
            
            for y in range (0,2):
                for x in range (0,2):
                    photo = self.board.create_image(self.posX + (x * 34) - (y * 34), self.posY + (y * 34), image = self.img) 
                    self.list_photo.append(photo)         